/*
** BeNES - Nintendo Entertaiment System Emulator for BeOS
**
** * 1999 by makoto yamagata
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef BENESAPP_H_DEFINED
#define BENESAPP_H_DEFINED

#include <app/Application.h>
#include <interface/MenuBar.h>
#include "NesROM.h"
#include "NesMainboard.h"

class BeNESWin;
class BeNESJoypad;

class BeNESApp: public BApplication {
	thread_id    mThread;
	BFilePanel*  mOpenPanel;
	BeNESWin*    mWindow;
	BeNESJoypad* mJoypad;
	NesROM       mROM;
	NesMainboard mMainboard;
public:
	
	BeNESApp(): 
		BApplication("application/x-vnd.mkt-BeNES"),
		mThread(0),
		mOpenPanel(NULL),
		mWindow(NULL),
		mJoypad(NULL) { ; }
	~BeNESApp() {
		endThread();
	}
private:
	// system
	void ReadyToRun();
	void RefsReceived(BMessage* msg);
	void MessageReceived(BMessage* msg);
	bool QuitRequested();
	// user
	void showRomInfo();
	void beginThread();
	void endThread();
	static int32 RunBeNES(void* arg);
	void setSkipFrames(int skip);
	void setFPS(int fps);
	void setSound(bool on);
};

#endif
