/** M6502: portable 6502 emulator ****************************/
/**                                                         **/
/**                       M6502opc.h                        **/
/**                                                         **/
/** This file contains implementation for the main table of **/
/** 6502 commands. It is included from 6502.c.              **/
/**                                                         **/
/** Copyright (C) Marat Fayzullin 1996                      **/
/**               Alex Krasivsky  1996                      **/
/** Modyfied      BERO            1998                      **/
/** modified      Makoto Yamagata 1999                      **/
/**     You are not allowed to distribute this software     **/
/**     commercially. Please, notify me, if you make any    **/
/**     changes to this file.                               **/
/*************************************************************/
#ifndef M6502OPC_H_DEFINED
#define M6502OPC_H_DEFINED

/*************************************************************/
byte ZNTable[256] =
{
  Z_FLAG,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
};

/*************************************************************/
static byte Cycles[256] =
{
  7,6,2,8,3,3,5,5,3,2,2,2,4,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7,
  6,6,2,8,3,3,5,5,4,2,2,2,4,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7,
  6,6,2,8,3,3,5,5,3,2,2,2,3,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7,
  6,6,2,8,3,3,5,5,4,2,2,2,5,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7,
  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4,
  2,6,2,6,4,4,4,4,2,5,2,5,5,5,5,5,
  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4,
  2,5,2,5,4,4,4,4,2,4,2,5,4,4,4,4,
  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7,
  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
};

/*************************************************************/
#define DEFVAL byte I;pair J,K
#define DEFVAL_IK byte I;pair K
#define DEFVAL_IJ byte I;pair J
#define DEFVAL_JK pair J,K
#define OP(nn) void M6502_##nn(register M6502 *R)
#define ILL \
  if(_TrapBadOps) { \
    printf \
    ( \
      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n", \
      (unsigned long)_User,Op6502(R,_PC_-1),(word)(_PC_-1) \
    ); \
    _Trace=1; \
  }

/*************************************************************/
/* BRK */
OP(00) {
  _PC_++;
  M_PUSH(_PC.B.h);
  M_PUSH(_PC.B.l);
  M_PUSH(_P|B_FLAG);
  _P=(_P|I_FLAG)&~D_FLAG;
  _PC.B.l=Op6502(R,0xFFFE);
  _PC.B.h=Op6502(R,0xFFFF);
}
/* JSR $ssss ABS */
OP(20) {
  pair K;
  K.B.l=Op6502(R,_PC_++);
  K.B.h=Op6502(R,_PC_);
  M_PUSH(_PC.B.h);
  M_PUSH(_PC.B.l);
  _PC=K;
}
/* RTI */
OP(40) {
  M_POP(_P);
  _P|=R_FLAG; 
  M_POP(_PC.B.l);
  M_POP(_PC.B.h);
}
OP(60) { M_POP(_PC.B.l); M_POP(_PC.B.h); _PC_++; } /* RTS */
OP(80) { ILL; } /* ILL */
OP(a0) { MR_Im(_Y); M_FL(_Y); } /* LDY #$ss IMM */
OP(c0) { DEFVAL_IK; MR_Im(I); M_CMP(_Y,I); } /* CPY #$ss IMM */
OP(e0) { DEFVAL_IK; MR_Im(I); M_CMP(_X,I); } /* CPX #$ss IMM */

OP(10) { if(_P&N_FLAG) _PC_++; else { M_JR; } } /* BPL * REL */
OP(30) { if(_P&N_FLAG) { M_JR; } else _PC_++; } /* BMI * REL */
OP(50) { if(_P&V_FLAG) _PC_++; else { M_JR; } } /* BVC * REL */
OP(70) { if(_P&V_FLAG) { M_JR; } else _PC_++; } /* BVS * REL */
OP(90) { if(_P&C_FLAG) _PC_++; else { M_JR; } } /* BCC * REL */
OP(b0) { if(_P&C_FLAG) { M_JR; } else _PC_++; } /* BCS * REL */
OP(d0) { if(_P&Z_FLAG) _PC_++; else { M_JR; } } /* BNE * REL */
OP(f0) { if(_P&Z_FLAG) { M_JR; } else _PC_++; } /* BEQ * REL */

OP(01) { DEFVAL; MR_Ix(I); M_ORA(I);     } /* ORA ($ss,x) INDEXINDIR */
OP(21) { DEFVAL; MR_Ix(I); M_AND(I);     } /* AND ($ss,x) INDEXINDIR */
OP(41) { DEFVAL; MR_Ix(I); M_EOR(I);     } /* EOR ($ss,x) INDEXINDIR */
OP(61) { DEFVAL; MR_Ix(I); M_ADC(I);     } /* ADC ($ss,x) INDEXINDIR */
OP(81) { DEFVAL_JK; MW_Ix(_A);              } /* STA ($ss,x) INDEXINDIR */
OP(a1) { DEFVAL_JK; MR_Ix(_A); M_FL(_A);   } /* LDA ($ss,x) INDEXINDIR */
OP(c1) { DEFVAL; MR_Ix(I); M_CMP(_A,I); } /* CMP ($ss,x) INDEXINDIR */
OP(e1) { DEFVAL; MR_Ix(I); M_SBC(I);     } /* SBC ($ss,x) INDEXINDIR */
             

OP(11) { DEFVAL; MR_Iy(I); M_ORA(I); } /* ORA ($ss),y INDIRINDEX */
OP(31) { DEFVAL; MR_Iy(I); M_AND(I); } /* AND ($ss),y INDIRINDEX */
OP(51) { DEFVAL; MR_Iy(I); M_EOR(I); } /* EOR ($ss),y INDIRINDEX */
OP(71) { DEFVAL; MR_Iy(I); M_ADC(I); } /* ADC ($ss),y INDIRINDEX */
OP(91) { DEFVAL_JK; MW_Iy(_A); } /* STA ($ss),y INDIRINDEX */
OP(b1) { DEFVAL_JK; MR_Iy(_A); M_FL(_A); } /* LDA ($ss),y INDIRINDEX */
OP(d1) { DEFVAL; MR_Iy(I); M_CMP(_A,I); } /* CMP ($ss),y INDIRINDEX */
OP(f1) { DEFVAL; MR_Iy(I); M_SBC(I); } /* SBC ($ss),y INDIRINDEX */

OP(02) { ILL; } /* ILL*/
OP(22) { ILL; } /* ILL*/
OP(42) { ILL; } /* ILL*/
OP(62) { ILL; } /* ILL*/
OP(82) { ILL; } /* ILL*/
OP(a2) { MR_Im(_X); M_FL(_X); } /* LDX #$ss IMM */
OP(c2) { ILL; } /* ILL*/
OP(e2) { ILL; } /* ILL*/

OP(12) { ILL; } /* ILL*/
OP(32) { ILL; } /* ILL*/
OP(52) { ILL; } /* ILL*/
OP(72) { ILL; } /* ILL*/
OP(92) { ILL; } /* ILL*/
OP(b2) { ILL; } /* ILL*/
OP(d2) { ILL; } /* ILL*/
OP(f2) { ILL; } /* ILL*/

OP(03) { ILL; } /* ILL*/
OP(23) { ILL; } /* ILL*/
OP(43) { ILL; } /* ILL*/
OP(63) { ILL; } /* ILL*/
OP(83) { ILL; } /* ILL*/
OP(a3) { ILL; } /* ILL*/
OP(c3) { ILL; } /* ILL*/
OP(e3) { ILL; } /* ILL*/

OP(13) { ILL; } /* ILL*/
OP(33) { ILL; } /* ILL*/
OP(53) { ILL; } /* ILL*/
OP(73) { ILL; } /* ILL*/
OP(93) { ILL; } /* ILL*/
OP(b3) { ILL; } /* ILL*/
OP(d3) { ILL; } /* ILL*/
OP(f3) { ILL; } /* ILL*/

OP(04) { ILL; } /* ILL*/
OP(24) { byte I; MR_Zp(I);M_BIT(I); }/* BIT $ss ZP */
OP(44) { ILL; } /* ILL*/
OP(64) { ILL; } /* ILL*/
OP(84) { MW_Zp(_Y); }/* STY $ss ZP */
OP(a4) { MR_Zp(_Y);M_FL(_Y); } /* LDY $ss ZP */
OP(c4) { DEFVAL_IK; MR_Zp(I);M_CMP(_Y,I); }  /* CPY $ss ZP */
OP(e4) { DEFVAL_IK; MR_Zp(I);M_CMP(_X,I); }  /* CPX $ss ZP */

OP(14) { ILL; } /* ILL*/
OP(34) { ILL; } /* ILL*/
OP(54) { ILL; } /* ILL*/
OP(74) { ILL; } /* ILL*/
OP(94) { MW_Zx(_Y); } /* STY $ss,x ZP,x */
OP(b4) { MR_Zx(_Y);M_FL(_Y); }  /* LDY $ss,x ZP,x */
OP(d4) { ILL; } /* ILL*/
OP(f4) { ILL; } /* ILL*/

OP(05) { byte I; MR_Zp(I);M_ORA(I); } /* ORA $ss ZP */
OP(25) { byte I; MR_Zp(I);M_AND(I); } /* AND $ss ZP */
OP(45) { byte I; MR_Zp(I);M_EOR(I); } /* EOR $ss ZP */
OP(65) { DEFVAL_IK; MR_Zp(I);M_ADC(I); } /* ADC $ss ZP */
OP(85) { MW_Zp(_A);         } /* STA $ss ZP */
OP(a5) { MR_Zp(_A);M_FL(_A); } /* LDA $ss ZP */
OP(c5) { DEFVAL_IK; MR_Zp(I);M_CMP(_A,I); } /* CMP $ss ZP */
OP(e5) { DEFVAL_IK; MR_Zp(I);M_SBC(I); } /* SBC $ss ZP */

OP(15) { byte I; MR_Zx(I);M_ORA(I); } /* ORA $ss,x ZP,x */
OP(35) { byte I; MR_Zx(I);M_AND(I); } /* AND $ss,x ZP,x */
OP(55) { byte I; MR_Zx(I);M_EOR(I); } /* EOR $ss,x ZP,x */
OP(75) { DEFVAL_IK; MR_Zx(I);M_ADC(I); } /* ADC $ss,x ZP,x */
OP(95) { MW_Zx(_A); } /* STA $ss,x ZP,x */
OP(b5) { MR_Zx(_A);M_FL(_A); } /* LDA $ss,x ZP,x */
OP(d5) { DEFVAL_IK; MR_Zx(I);M_CMP(_A,I); } /* CMP $ss,x ZP,x */
OP(f5) { DEFVAL_IK; MR_Zx(I);M_SBC(I); } /* SBC $ss,x ZP,x */

OP(06) { byte I; MM_Zp(M_ASL); } /* ASL $ss ZP */
OP(26) { DEFVAL_IK; MM_Zp(M_ROL); } /* ROL $ss ZP */
OP(46) { byte I; MM_Zp(M_LSR); } /* LSR $ss ZP */
OP(66) { DEFVAL_IK; MM_Zp(M_ROR); } /* ROR $ss ZP */
OP(86) { MW_Zp(_X); } /* STX $ss ZP */
OP(a6) { MR_Zp(_X);M_FL(_X); } /* LDX $ss ZP */
OP(c6) { byte I; MM_Zp(M_DEC); } /* DEC $ss ZP */
OP(e6) { byte I; MM_Zp(M_INC); } /* INC $ss ZP */

OP(16) { byte I; MM_Zx(M_ASL); } /* ASL $ss,x ZP,x */
OP(36) { DEFVAL_IK; MM_Zx(M_ROL); } /* ROL $ss,x ZP,x */
OP(56) { byte I; MM_Zx(M_LSR); } /* LSR $ss,x ZP,x */
OP(76) { DEFVAL_IK; MM_Zx(M_ROR); } /* ROR $ss,x ZP,x */
OP(96) { MW_Zy(_X); } /* STX $ss,y ZP,y */
OP(b6) { MR_Zy(_X);M_FL(_X); } /* LDX $ss,y ZP,y */
OP(d6) { byte I; MM_Zx(M_DEC); } /* DEC $ss,x ZP,x */
OP(f6) { byte I; MM_Zx(M_INC); } /* INC $ss,x ZP,x */

OP(07) { ILL; } /* ILL*/
OP(27) { ILL; } /* ILL*/
OP(47) { ILL; } /* ILL*/
OP(67) { ILL; } /* ILL*/
OP(87) { ILL; } /* ILL*/
OP(a7) { ILL; } /* ILL*/
OP(c7) { ILL; } /* ILL*/
OP(e7) { ILL; } /* ILL*/

OP(17) { ILL; } /* ILL*/
OP(37) { ILL; } /* ILL*/
OP(57) { ILL; } /* ILL*/
OP(77) { ILL; } /* ILL*/
OP(97) { ILL; } /* ILL*/
OP(b7) { ILL; } /* ILL*/
OP(d7) { ILL; } /* ILL*/
OP(f7) { ILL; } /* ILL*/

OP(08) { M_PUSH(_P); } /* PHP */
OP(28) { /* PLP*/
  byte I; 
  M_POP(I);
  if((_IRequest!=INT_NONE)&&((I^_P)&~I&I_FLAG))
  {
    _AfterCLI=1;
    _IBackup=_ICount;
    _ICount=1;
  }
  _P=I|R_FLAG;
}
OP(48) { M_PUSH(_A); } /* PHA */
OP(68) { M_POP(_A);M_FL(_A); } /* PLA */
OP(88) { _Y--;M_FL(_Y); } /* DEY */
OP(a8) { _Y=_A;M_FL(_Y); } /* TAY */
OP(c8) { _Y++;M_FL(_Y); } /* INY */
OP(e8) { _X++;M_FL(_X); } /* INX */

OP(18) { _P&=~C_FLAG; } /* CLC */
OP(38) { _P|=C_FLAG; } /* SEC */
OP(58) { /* CLI */
  if((_IRequest!=INT_NONE)&&(_P&I_FLAG))
  {
    _AfterCLI=1;
    _IBackup=_ICount;
    _ICount=1;
  }
  _P&=~I_FLAG;
}
OP(78) { _P|=I_FLAG; } /* SEI */
OP(98) { _A=_Y;M_FL(_A); } /* TYA */
OP(b8) { _P&=~V_FLAG; } /* CLV */
OP(d8) { _P&=~D_FLAG; } /* CLD */
OP(f8) { _P|=D_FLAG; } /* SED */

OP(09) { byte I; MR_Im(I);M_ORA(I); } /* ORA #$ss IMM */
OP(29) { byte I; MR_Im(I);M_AND(I); } /* AND #$ss IMM */
OP(49) { byte I; MR_Im(I);M_EOR(I); } /* EOR #$ss IMM */
OP(69) { DEFVAL_IK; MR_Im(I);M_ADC(I); } /* ADC #$ss IMM */
OP(89) { ILL; } /* ILL*/
OP(a9) { MR_Im(_A);M_FL(_A); } /* LDA #$ss IMM */
OP(c9) { DEFVAL_IK; MR_Im(I);M_CMP(_A,I); } /* CMP #$ss IMM */
OP(e9) { DEFVAL_IK; MR_Im(I);M_SBC(I); } /* SBC #$ss IMM */

OP(19) { DEFVAL_IJ; MR_Ay(I);M_ORA(I); } /* ORA $ssss,y ABS,y */
OP(39) { DEFVAL_IJ; MR_Ay(I);M_AND(I); } /* AND $ssss,y ABS,y */
OP(59) { DEFVAL_IJ; MR_Ay(I);M_EOR(I); } /* EOR $ssss,y ABS,y */
OP(79) { DEFVAL; MR_Ay(I);M_ADC(I); } /* ADC $ssss,y ABS,y */
OP(99) { pair J; MW_Ay(_A); } /* STA $ssss,y ABS,y */
OP(b9) { pair J; MR_Ay(_A);M_FL(_A); } /* LDA $ssss,y ABS,y */
OP(d9) { DEFVAL; MR_Ay(I);M_CMP(_A,I); } /* CMP $ssss,y ABS,y */
OP(f9) { DEFVAL; MR_Ay(I);M_SBC(I); } /* SBC $ssss,y ABS,y */

OP(0a) { M_ASL(_A); } /* ASL a ACC */
OP(2a) { pair K; M_ROL(_A); } /* ROL a ACC */
OP(4a) { M_LSR(_A); } /* LSR a ACC */
OP(6a) { pair K; M_ROR(_A); } /* ROR a ACC */
OP(8a) { _A=_X;M_FL(_A); } /* TXA */
OP(aa) { _X=_A;M_FL(_X); } /* TAX */
OP(ca) { _X--;M_FL(_X); } /* DEX */
OP(ea) { ; } /* NOP*/

OP(1a) { ILL; } /* ILL*/
OP(3a) { ILL; } /* ILL*/
OP(5a) { ILL; } /* ILL*/
OP(7a) { ILL; } /* ILL*/
OP(9a) { _S=_X; } /* TXS */
OP(ba) { _X=_S;M_FL(_X); /* added by makoto */ } /* TSX */
OP(da) { ILL; } /* ILL*/
OP(fa) { ILL; } /* ILL*/

OP(0b) { ILL; } /* ILL*/
OP(2b) { ILL; } /* ILL*/
OP(4b) { ILL; } /* ILL*/
OP(6b) { ILL; } /* ILL*/
OP(8b) { ILL; } /* ILL*/
OP(ab) { ILL; } /* ILL*/
OP(cb) { ILL; } /* ILL*/
OP(eb) { ILL; } /* ILL*/

OP(1b) { ILL; } /* ILL*/
OP(3b) { ILL; } /* ILL*/
OP(5b) { ILL; } /* ILL*/
OP(7b) { ILL; } /* ILL*/
OP(9b) { ILL; } /* ILL*/
OP(bb) { ILL; } /* ILL*/
OP(db) { ILL; } /* ILL*/
OP(fb) { ILL; } /* ILL*/

OP(0c) { ILL; } /* 2 ILL*/
OP(2c) { DEFVAL_IJ; MR_Ab(I);M_BIT(I); } /* BIT $ssss ABS */
OP(4c) { pair K; M_LDWORD(K);_PC=K; }/* JMP $ssss ABS */
OP(6c) { /* JMP ($ssss) ABDINDIR */
  pair K;
  M_LDWORD(K);
  _PC.B.l=Rd6502(R,K.W++);
  _PC.B.h=Rd6502(R,K.W);
}
OP(8c) { pair J; MW_Ab(_Y); } /* STY $ssss ABS */
OP(ac) { pair J; MR_Ab(_Y);M_FL(_Y); } /* LDY $ssss ABS */
OP(cc) { DEFVAL; MR_Ab(I);M_CMP(_Y,I); } /* CPY $ssss ABS */
OP(ec) { DEFVAL; MR_Ab(I);M_CMP(_X,I); } /* CPX $ssss ABS */

OP(1c) { ILL; } /* ILL*/
OP(3c) { ILL; } /* ILL*/
OP(5c) { ILL; } /* ILL*/
OP(7c) { ILL; } /* ILL*/
OP(9c) { ILL; } /* ILL*/
OP(bc) { pair J; MR_Ax(_Y);M_FL(_Y); } /* LDY $ssss,x ABS,x */
OP(dc) { ILL; } /* ILL*/
OP(fc) { ILL; } /* ILL*/

OP(0d) { DEFVAL_IJ; MR_Ab(I);M_ORA(I); } /* ORA $ssss ABS */
OP(2d) { DEFVAL_IJ; MR_Ab(I);M_AND(I); } /* AND $ssss ABS */
OP(4d) { DEFVAL_IJ; MR_Ab(I);M_EOR(I); } /* EOR $ssss ABS */
OP(6d) { DEFVAL; MR_Ab(I);M_ADC(I); } /* ADC $ssss ABS */
OP(8d) { pair J; MW_Ab(_A); } /* STA $ssss ABS */
OP(ad) { pair J; MR_Ab(_A);M_FL(_A); } /* LDA $ssss ABS */
OP(cd) { DEFVAL; MR_Ab(I);M_CMP(_A,I); } /* CMP $ssss ABS */
OP(ed) { DEFVAL; MR_Ab(I);M_SBC(I); } /* SBC $ssss ABS */

OP(1d) { DEFVAL_IJ; MR_Ax(I);M_ORA(I); } /* ORA $ssss,x ABS,x */
OP(3d) { DEFVAL_IJ; MR_Ax(I);M_AND(I); } /* AND $ssss,x ABS,x */
OP(5d) { DEFVAL_IJ; MR_Ax(I);M_EOR(I); } /* EOR $ssss,x ABS,x */
OP(7d) { DEFVAL; MR_Ax(I);M_ADC(I); } /* ADC $ssss,x ABS,x */
OP(9d) { pair J; MW_Ax(_A); }  /* STA $ssss,x ABS,x */
OP(bd) { pair J; MR_Ax(_A);M_FL(_A); } /* LDA $ssss,x ABS,x */
OP(dd) { DEFVAL; MR_Ax(I);M_CMP(_A,I); } /* CMP $ssss,x ABS,x */
OP(fd) { DEFVAL; MR_Ax(I);M_SBC(I); } /* SBC $ssss,x ABS,x */

OP(0e) { DEFVAL_IJ; MM_Ab(M_ASL); } /* ASL $ssss ABS */
OP(2e) { DEFVAL; MM_Ab(M_ROL); } /* ROL $ssss ABS */
OP(4e) { DEFVAL_IJ; MM_Ab(M_LSR); } /* LSR $ssss ABS */
OP(6e) { DEFVAL; MM_Ab(M_ROR); } /* ROR $ssss ABS */
OP(8e) { pair J; MW_Ab(_X); } /* STX $ssss ABS */
OP(ae) { pair J; MR_Ab(_X);M_FL(_X); } /* LDX $ssss ABS */
OP(ce) { DEFVAL_IJ; MM_Ab(M_DEC); } /* DEC $ssss ABS */
OP(ee) { DEFVAL_IJ; MM_Ab(M_INC); } /* INC $ssss ABS */

OP(1e) { DEFVAL_IJ; MM_Ax(M_ASL); } /* ASL $ssss,x ABS,x */
OP(3e) { DEFVAL; MM_Ax(M_ROL); } /* ROL $ssss,x ABS,x */
OP(5e) { DEFVAL_IJ; MM_Ax(M_LSR); } /* LSR $ssss,x ABS,x */
OP(7e) { DEFVAL; MM_Ax(M_ROR); } /* ROR $ssss,x ABS,x */
OP(9e) { ILL; } /* ILL*/
OP(be) { pair J; MR_Ay(_X);M_FL(_X); } /* LDX $ssss,y ABS,y */
OP(de) { DEFVAL_IJ; MM_Ax(M_DEC); } /* DEC $ssss,x ABS,x */
OP(fe) { DEFVAL_IJ; MM_Ax(M_INC); } /* INC $ssss,x ABS,x */

OP(0f) { ILL; } /* ILL*/
OP(2f) { ILL; } /* ILL*/
OP(4f) { ILL; } /* ILL*/
OP(6f) { ILL; } /* ILL*/
OP(8f) { ILL; } /* ILL*/
OP(af) { ILL; } /* ILL*/
OP(cf) { ILL; } /* ILL*/
OP(ef) { ILL; } /* ILL*/

OP(1f) { ILL; } /* ILL*/
OP(3f) { ILL; } /* ILL*/
OP(5f) { ILL; } /* ILL*/
OP(7f) { ILL; } /* ILL*/
OP(9f) { ILL; } /* ILL*/
OP(bf) { ILL; } /* ILL*/
OP(df) { ILL; } /* ILL*/
OP(ff) { ILL; } /* ILL*/

/*************************************************************/
static void (*M6502opc[256])(register M6502 *R) = {
	M6502_00,M6502_01,M6502_02,M6502_03,M6502_04,M6502_05,M6502_06,M6502_07,
	M6502_08,M6502_09,M6502_0a,M6502_0b,M6502_0c,M6502_0d,M6502_0e,M6502_0f,
	M6502_10,M6502_11,M6502_12,M6502_13,M6502_14,M6502_15,M6502_16,M6502_17,
	M6502_18,M6502_19,M6502_1a,M6502_1b,M6502_1c,M6502_1d,M6502_1e,M6502_1f,
	M6502_20,M6502_21,M6502_22,M6502_23,M6502_24,M6502_25,M6502_26,M6502_27,
	M6502_28,M6502_29,M6502_2a,M6502_2b,M6502_2c,M6502_2d,M6502_2e,M6502_2f,
	M6502_30,M6502_31,M6502_32,M6502_33,M6502_34,M6502_35,M6502_36,M6502_37,
	M6502_38,M6502_39,M6502_3a,M6502_3b,M6502_3c,M6502_3d,M6502_3e,M6502_3f,
	M6502_40,M6502_41,M6502_42,M6502_43,M6502_44,M6502_45,M6502_46,M6502_47,
	M6502_48,M6502_49,M6502_4a,M6502_4b,M6502_4c,M6502_4d,M6502_4e,M6502_4f,
	M6502_50,M6502_51,M6502_52,M6502_53,M6502_54,M6502_55,M6502_56,M6502_57,
	M6502_58,M6502_59,M6502_5a,M6502_5b,M6502_5c,M6502_5d,M6502_5e,M6502_5f,
	M6502_60,M6502_61,M6502_62,M6502_63,M6502_64,M6502_65,M6502_66,M6502_67,
	M6502_68,M6502_69,M6502_6a,M6502_6b,M6502_6c,M6502_6d,M6502_6e,M6502_6f,
	M6502_70,M6502_71,M6502_72,M6502_73,M6502_74,M6502_75,M6502_76,M6502_77,
	M6502_78,M6502_79,M6502_7a,M6502_7b,M6502_7c,M6502_7d,M6502_7e,M6502_7f,
	M6502_80,M6502_81,M6502_82,M6502_83,M6502_84,M6502_85,M6502_86,M6502_87,
	M6502_88,M6502_89,M6502_8a,M6502_8b,M6502_8c,M6502_8d,M6502_8e,M6502_8f,
	M6502_90,M6502_91,M6502_92,M6502_93,M6502_94,M6502_95,M6502_96,M6502_97,
	M6502_98,M6502_99,M6502_9a,M6502_9b,M6502_9c,M6502_9d,M6502_9e,M6502_9f,
	M6502_a0,M6502_a1,M6502_a2,M6502_a3,M6502_a4,M6502_a5,M6502_a6,M6502_a7,
	M6502_a8,M6502_a9,M6502_aa,M6502_ab,M6502_ac,M6502_ad,M6502_ae,M6502_af,
	M6502_b0,M6502_b1,M6502_b2,M6502_b3,M6502_b4,M6502_b5,M6502_b6,M6502_b7,
	M6502_b8,M6502_b9,M6502_ba,M6502_bb,M6502_bc,M6502_bd,M6502_be,M6502_bf,
	M6502_c0,M6502_c1,M6502_c2,M6502_c3,M6502_c4,M6502_c5,M6502_c6,M6502_c7,
	M6502_c8,M6502_c9,M6502_ca,M6502_cb,M6502_cc,M6502_cd,M6502_ce,M6502_cf,
	M6502_d0,M6502_d1,M6502_d2,M6502_d3,M6502_d4,M6502_d5,M6502_d6,M6502_d7,
	M6502_d8,M6502_d9,M6502_da,M6502_db,M6502_dc,M6502_dd,M6502_de,M6502_df,
	M6502_e0,M6502_e1,M6502_e2,M6502_e3,M6502_e4,M6502_e5,M6502_e6,M6502_e7,
	M6502_e8,M6502_e9,M6502_ea,M6502_eb,M6502_ec,M6502_ed,M6502_ee,M6502_ef,
	M6502_f0,M6502_f1,M6502_f2,M6502_f3,M6502_f4,M6502_f5,M6502_f6,M6502_f7,
	M6502_f8,M6502_f9,M6502_fa,M6502_fb,M6502_fc,M6502_fd,M6502_fe,M6502_ff
};

#endif