/*
** BeNES - Nintendo Entertaiment System Emulator for BeOS
**
** * 1999 by makoto yamagata
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "NesMapperFactory.h"
#include "NesMapper0.h"
#include "NesMapper1.h"
#include "NesMapper2.h"
#include "NesMapper3.h"
#include "NesMapper4.h"
#include "NesMapper7.h"

NesMapperFactory NesMapperFactory::mInstance;

NesAbstructMapper* NesMapperFactory::Create(int mapperNumber)
{
	switch (mapperNumber) {
	case 0: return new NesMapper0;
	case 1: return new NesMapper1;
	case 2: return new NesMapper2;
	case 3: return new NesMapper3;
	case 4: return new NesMapper4;
	case 7: return new NesMapper7;
	default: return NULL;
	}
}

