/*
** BeNES - Nintendo Entertaiment System Emulator for BeOS
**
** * 1999 by makoto yamagata
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef JOYPAD_H_DEFINED
#define JOYPAD_H_DEFINED

#include "NesTypes.h"

class NesJoypad {
	uchar mAccessBit;
	uchar mJoypad;
public:
	NesJoypad(): mAccessBit(0), mJoypad(0) { ; }
	void reset() { mAccessBit = 0; }
	uchar read() { 
		uchar bit = ((mJoypad>>mAccessBit)&0x01);
		mAccessBit = (++mAccessBit)&0x07;
		return bit;
	}
	void pushA() { mJoypad |= 0x01; }
	void pushB() {  mJoypad |= 0x02; }
	void pushSelect() {  mJoypad |= 0x04; }
	void pushStart() {  mJoypad |= 0x08; }
	void pushUp() { mJoypad |= 0x10; }
	void pushDown() { mJoypad |= 0x20; }
	void pushLeft() { mJoypad |= 0x40; }
	void pushRight() { mJoypad |= 0x80; }

	void releaseA() { mJoypad &= ~0x01; }
	void releaseB() {  mJoypad &= ~0x02; }
	void releaseSelect() {  mJoypad &= ~0x04; }
	void releaseStart() {  mJoypad &= ~0x08; }
	void releaseUp() { mJoypad &= ~0x10; }
	void releaseDown() { mJoypad &= ~0x20; }
	void releaseLeft() { mJoypad &= ~0x40; } 
	void releaseRight() { mJoypad &= ~0x80; }
};

#endif
