/*
** BeNES - Nintendo Entertaiment System Emulator for BeOS
**
** * 1999 by makoto yamagata
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
//
// Picture Processor Unit (PPU)
//
#ifndef NESPPU_H_DEFINED
#define NESPPU_H_DEFINED

#include "NesPPURegisters.h"
#include "NesCPUInterface.h"
#include "NesDisplay.h"
#include "NesPPUImpl.h"

class NesIO;

class NesPPU: public NesPPUImpl {
	NesVirtualScreen mVirtualScreen;
	NesVirtualScreen mScreenMask;
	NesDisplay* mDisplay;
	int mFrameCounter;
	int mSkipFrames;
	int mSpriteHitLine;
	int mNameTableBase;
public:
	NesPPU():
		mDisplay(NULL), 
		mFrameCounter(0),
		mSkipFrames(0),
		mSpriteHitLine(0) { ; }
	void connect(NesDisplay* display) { mDisplay = display; } 
	void setSkipFrames(int skip) { mSkipFrames = skip; }
private:
	void renderLine(int scanline);
	void putSprite(int scanline);

	int spriteHit0y();

private: friend NesIO;//Access from NesIO Class Only
 	void init();
	
	int scanLine(NesCPUInterface* cpu);
};

#endif
